package kr.co.vividnext.sodalive.admin.calculate.ratio

import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.data.domain.Pageable
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PostMapping
import org.springframework.web.bind.annotation.RequestBody
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/calculate/ratio")
class CreatorSettlementRatioController(private val service: CreatorSettlementRatioService) {
    @PostMapping
    fun createCreatorSettlementRatio(
        @RequestBody request: CreateCreatorSettlementRatioRequest
    ) = ApiResponse.ok(service.createCreatorSettlementRatio(request))

    @GetMapping
    fun getCreatorSettlementRatio(
        pageable: Pageable
    ) = ApiResponse.ok(
        service.getCreatorSettlementRatio(
            offset = pageable.offset,
            limit = pageable.pageSize.toLong()
        )
    )
}
