package kr.co.vividnext.sodalive.content.hashtag

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.content.hashtag.QHashTag.hashTag
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface HashTagRepository : JpaRepository<HashTag, Long>, HashTagQueryRepository

interface HashTagQueryRepository {
    fun findByTag(tag: String): HashTag?
}

@Repository
class HashTagQueryRepositoryImpl(private val queryFactory: JPAQueryFactory) : HashTagQueryRepository {
    override fun findByTag(tag: String): HashTag? {
        return queryFactory
            .selectFrom(hashTag)
            .where(hashTag.tag.eq(tag))
            .fetchOne()
    }
}
