package kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.comment

import kr.co.vividnext.sodalive.common.BaseEntity
import kr.co.vividnext.sodalive.explorer.profile.creatorCommunity.CreatorCommunity
import kr.co.vividnext.sodalive.member.Member
import javax.persistence.Column
import javax.persistence.Entity
import javax.persistence.FetchType
import javax.persistence.JoinColumn
import javax.persistence.ManyToOne
import javax.persistence.OneToMany

@Entity
data class CreatorCommunityComment(
    @Column(columnDefinition = "TEXT", nullable = false)
    var comment: String,
    var isActive: Boolean = true
) : BaseEntity() {
    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "parent_id", nullable = true)
    var parent: CreatorCommunityComment? = null
        set(value) {
            value?.children?.add(this)
            field = value
        }

    @OneToMany(mappedBy = "parent")
    var children: MutableList<CreatorCommunityComment> = mutableListOf()

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "member_id", nullable = false)
    var member: Member? = null

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinColumn(name = "creator_community_id", nullable = false)
    var creatorCommunity: CreatorCommunity? = null
}
