package kr.co.vividnext.sodalive.live.roulette

import org.springframework.data.redis.core.RedisHash
import org.springframework.data.redis.core.index.Indexed
import javax.persistence.Id

@RedisHash("newRoulette")
data class NewRoulette(
    @Id
    val id: Long,
    @Indexed
    val creatorId: Long,
    var can: Int,
    var isActive: Boolean,
    var items: List<RouletteItem> = mutableListOf()
)

data class RouletteItem(
    val title: String,
    val weight: Int,
    val percentage: Float = 0.00F
)
